import { Tool } from "./base_tool.js";
import { Tools } from "./tool_manager.js";
import { Pattern } from "./../modules/pattern.js";
class BlockReplacerTool extends Tool {
    constructor(pattern) {
        super();
        this.noDelay = true;
        this.permission = "worldedit.repl";
        this.useOn = function (self, player, session, loc) {
            if (player.isSneaking) {
                self.breakOn(self, player, session, loc);
            }
            else {
                self.pattern.setBlock(player.dimension.getBlock(loc));
            }
        };
        this.breakOn = function (self, player, session, loc) {
            self.pattern = new Pattern();
            self.pattern.addBlock(player.dimension.getBlock(loc).permutation);
        };
        this.pattern = pattern;
    }
}
Tools.register(BlockReplacerTool, "replacer_wand");
